<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;

class FilioperPrincipalController extends TeknisaCrud
{
    protected $dataSourceName = "filioper";

    public function save(DTO\Request $request, DTO\Response $response)
    {
        foreach($request->getDataSet()->getRows() as $row)
        {
            try
            {
                if($row["__is_new"])
                {

                    foreach($row["NMFILIAL_MULT"] as $cdfilial)
                    {
                    	$row["CDFILIAL"] = $cdfilial;
                    	parent::save($request, $response);
                    }
                }
                else
                {
                    parent::save($request, $response);
                }
            }catch(\Exception $e)
            {
                $response->setError(new Error($e->getMessage(), $e->getCode()));
            }
        }
    }

}