<?php
namespace Teknisa\CRM\Factory;

use Doctrine\ORM\EntityManager;

class crmClienteFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection       = $entityManager->getConnection();
    }
    
    public function insertProspectEvolNextTask($paramsInsertProspectEvolNextTask){

        $insert = "INSERT INTO FILACONTATO (DSFILACONTATO,DTPLANFILACONTA,CDOPERREAL,NRSEQFILACONTA,NRORG,DTINCLUSAO,NRORGINCLUSAO,
                               CDOPERINCLUSAO,NRPARCNEGOCIO,IDORIGFILACONTA,IDATIVO,NRCONTATO, NRPRIORFILACONT,NRSEQCONTATO, NRSEQINTERLOCUTOR, DSEMAILTAREFA, DSTELEFONETAREFA, NRSEQCLASSIFICATAREFA)
                    VALUES (:DSFILACONTATO,
                            :DTPLANFILACONTA,
                            :CDOPERREAL,
                            :NRSEQFILACONTA,
                            :NRORG,
                             SYSDATE,
                            :NRORGINCLUSAO,
                            :CDOPERINCLUSAO,
                            :NRPARCNEGOCIO,
                             'M',
                             'S',
                            :NRCONTATO,
                            :NRPRIORFILACONT,
                            :NRSEQCONTATO,
                            :NRSEQINTERLOCUTOR,
                            :DSEMAILTAREFA,
                            :DSTELEFONETAREFA,
                            :NRSEQCLASSIFICATAREFA)";
                 
        
            $std = $this->connection->prepare($insert);
            $std->execute($paramsInsertProspectEvolNextTask);
        
    }
    
    public function verificaTarefas($paramsVerificaTarefas){
        $select = "SELECT FC.NRSEQFILACONTA, FC.CDOPERREAL
                     FROM FILACONTATO FC
                        LEFT JOIN PARCNEGOCIO PN
                         ON PN.NRPARCNEGOCIO = FC.NRPARCNEGOCIO
                          AND PN.NRORG = PN.NRORG
                    WHERE FC.NRPARCNEGOCIO = :NRPARCNEGOCIO
                      AND FC.NRORG = :NRORG 
                      AND FC.DTREALFILACONTA IS NULL
                      AND FC.IDATIVO = 'S' 
                      AND PN.IDATIVO = 'S'
                    ";
                      
        
            $std = $this->connection->prepare($select);
            $std->execute($paramsVerificaTarefas);
            $tarefas = $std->fetchAll();
            return $tarefas;
        
    }
    
    public function selectProspectContact($paramsSelectProspectContact){
        $select = "SELECT NRSEQCONTATO
                     FROM CONTATO
                    WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO
                      AND NRORG = :NRORG
                      AND UPPER(DSREFECONT) LIKE '%REFERENTE AO LEAD%'";
                      
        
            $std = $this->connection->prepare($select);
            $std->execute($paramsSelectProspectContact);
            $nrseqcontato = $std->fetchAll();
            return $nrseqcontato;
        
    }
    
    public function requestForInsertNrseqcontatoForNewOpportunity($paramsUpdateOpportunity){
        
        $update = "UPDATE CRM_OPORTUNI 
                      SET NRSEQCONTATO = :NRSEQCONTATO,
                          NRCONTATO = :NRSEQCONTATO    
                    WHERE NRSEQOPORT = :NRSEQOPORT";
        
        
            $std = $this->connection->prepare($update);
            $std->execute($paramsUpdateOpportunity);
         
    }
    
    public function requestForUpdatePartnerType($paramsUpdatePartnerType){
        
        $update = "UPDATE PARCNEGOCIO
                      SET CDTIPOPARCPRINCIPAL = 'CLIENTE'
                    WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO";
                    
        
            $std = $this->connection->prepare($update);
            $std->execute($paramsUpdatePartnerType);
         
        
    }
    
    public function requestForInsertPartnershipOfTypeClient($paramsInsertPartnership){
        
        $insert = "INSERT INTO PARCERIA
                        (NRPARCERIA, NRPARCNEGOCIO, CDTIPOPARCEIRO, NRORG, IDATIVO, DTINCLUSAO,
                            NRORGINCLUSAO, CDOPERINCLUSAO)
                    VALUES(
                        :NRPARCERIA,
                        :NRPARCNEGOCIO,
                         'CLIENTE',
                        :NRORG,
                         'S',
                         SYSDATE,
                        :NRORGINCLUSAO,
                        :CDOPERINCLUSAO
                    )";
    
        
            $std = $this->connection->prepare($insert);
            $std->execute($paramsInsertPartnership);
         
        
    }
    
    public function requestForDeactivateProspect($paramsUpdateProspect){
        
        $update = "UPDATE PROSPECT
                      SET IDATIVO = 'N'
                    WHERE CDPROSPECT = :CDPROSPECT";
        
        
            $std = $this->connection->prepare($update);
            $std->execute($paramsUpdateProspect);
        
    }
    
    public function requestForInsertClientAddress($paramsInsertClientAddress){
        $insert = "INSERT INTO ENDECLIE (CDCLIENTE, IDTPENDECLIE, CDPAIS, SGESTADO, CDMUNICIPIO, CDBAIRRO, DSENDECLIE, 
                      NMBAIRCLIE, DSCOMPENDCLI, NRCEPCLIE, NRTELECLIE, NRRAMALCLIE ,DSEMAILCLIE, NRENDERECOPARC, 
                      NRORG, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, IDATIVO)
              VALUES (
                :CDCLIENTE,
                :IDTPENDECLIE,
                :CDPAIS,
                :SGESTADO,
                :CDMUNICIPIO,
                :CDBAIRRO,
                :DSENDECLIE,
                :NMBAIRCLIE,
                :DSCOMPENDCLI,
                :NRCEPCLIE,
                :NRTELECLIE,
                :NRRAMALCLIE,
                :DSEMAILCLIE,
                :NRENDERECOPARC, 
                :NRORG,
                SYSDATE,
                :NRORGINCLUSAO,
                :CDOPERINCLUSAO,
                'S'
              )";
        
        
            $std = $this->connection->prepare($insert);
            $std->execute($paramsInsertClientAddress);
        
    }
    
    public function requestForSelectProspectAddress($paramsSelectProspectAddress){
        
        $select = "SELECT IDTPENDEPROS, CDPAIS, SGESTADO, CDMUNICIPIO, CDBAIRRO, DSENDEPROS,
                NMBAIRPROS, DSCOMPENDPRO, NRCEPPROS, NRTELEPROS, NRRAMALPROS, DSEMAILPROS, NRENDERECOPARC
                FROM ENDEPROSPECT
                    WHERE CDPROSPECT = :CDPROSPECT
                        AND NRORG = :NRORG
                        AND CDPAIS IS NOT NULL
                        AND SGESTADO IS NOT NULL
                        AND CDMUNICIPIO IS NOT NULL";
        
        
            $std = $this->connection->prepare($select);
            $std->execute($paramsSelectProspectAddress);
            return $std->fetchAll();
        
        
    }
    
     public function getOperador($paramsSelectOperador){
        
        $select = "SELECT INITCAP(NMOPERADOR) NMOPERADOR FROM OPERADOR
                        WHERE CDOPERADOR = :CDOPERREAL
                            AND NRORG = :NRORG";
        
        
            $std = $this->connection->prepare($select);
            $std->execute($paramsSelectOperador);
            return $std->fetchAll();
        
        
    }
    
    public function getParceiro($paramsSelectOperador){
        
        $select = "SELECT INITCAP(NMPRINCIPALPARC) NMPRINCIPALPARC FROM PARCNEGOCIO
                        WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO
                            AND NRORG = :NRORG";
        
        
            $std = $this->connection->prepare($select);
            $std->execute($paramsSelectOperador);
            return $std->fetchAll();
        
        
    }
    
    public function requestForSetTaskEndDate($paramsSetTaskEndDate){
        
        $update = "UPDATE FILACONTATO 
                   SET DTREALFILACONTA = SYSDATE
                   WHERE NRSEQFILACONTA = :NRSEQFILACONTA";
        
        
            $std = $this->connection->prepare($update);
            $std->execute($paramsSetTaskEndDate);
        
        
    }
    
    public function requestForDeactivateProspectTask($taskUpdateParams){
        
        $update = "UPDATE FILACONTATO
                   SET IDATIVO = 'N'
                   WHERE NRSEQFILACONTA = :NRSEQFILACONTA";
                   
        
            
            $std = $this->connection->prepare($update);
            $std->execute($taskUpdateParams);
            
        
        
    }
    
     public function getInterlocutorParc($nrrelacionaparc, $nrorg){
            
        $selectInterlocutorParc = "SELECT NRPARCNEGRELAC
                                        FROM RELACIONAPARC
                                        WHERE NRRELACIONAPARC = '$nrrelacionaparc'
                                        AND NRORG = '$nrorg' " ;
        
        
        
            $std = $this->connection->prepare($selectInterlocutorParc);
            $std->execute();
            $nrparcnegocio = $std->fetchAll();
            
        
        if(isset($nrparcnegocio[0]))
            return $nrparcnegocio[0]['NRPARCNEGRELAC'];
        
    }
    
    public function getEnderecoparcInterlocutor($nrparcnegocioInterlocutor, $nrorg){
            
        $selectInterlocutorParc = "SELECT NRENDERECOPARC
                                        FROM ENDERECOPARC
                                        WHERE NRPARCNEGOCIO = '$nrparcnegocioInterlocutor'
                                        AND NRORG = '$nrorg' " ;

        
        
            $std = $this->connection->prepare($selectInterlocutorParc);
            $std->execute();
            $nrenderecoparcInterlocutor = $std->fetchAll();
            
        
        if(isset($nrenderecoparcInterlocutor[0]))
            return $nrenderecoparcInterlocutor[0]['NRENDERECOPARC'];
        else
            return false;
        
    }
    
    public function replicaEnderecoparcInterlocutor($paramsUpdateEndeparc){
            
        $update = "UPDATE ENDERECOPARC SET CDTIPOENDERECO = :CDTIPOENDERECO,
                        DTULTATU = SYSDATE, NRORGULTATU = :NRORGULTATU, CDOPERULTATU = :CDOPERULTATU, CDPAIS = :CDPAIS, SGESTADO = :SGESTADO, CDMUNICIPIO = :CDMUNICIPIO, CDBAIRRO = :CDBAIRRO, NMBAIRROENDERECO = :NMBAIRROENDERECO,
                       DSENDERECO = :DSENDERECO,  NRCEPENDERECO = :NRCEPENDERECO
                    WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO AND NRENDERECOPARC = :NRENDERECOPARC AND NRORG = :NRORG";
        
            $std = $this->connection->prepare($update);
            $std->execute($paramsUpdateEndeparc);
        
        
    }
    
    public function insertEnderecoparc($paramsInsertEndeparc){

        $insert = "INSERT INTO ENDERECOPARC (IDATIVO, NRPARCNEGOCIO, NRORG, NRENDERECOPARC, CDTIPOENDERECO,
                        DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, CDPAIS, SGESTADO, CDMUNICIPIO, CDBAIRRO, NMBAIRROENDERECO, DSCOMPLEENDERECO,
                        NRCEPENDERECO, DSENDERECO, NRIMOVELENDERECO)
         VALUES (:IDATIVO,
                 :NRPARCNEGOCIO,
                 :NRORG,
                 :NRENDERECOPARC,
                 :CDTIPOENDERECO,
                  SYSDATE,
                 :NRORGINCLUSAO,
                 :CDOPERINCLUSAO,
                 :CDPAIS,
                 :SGESTADO,
                 :CDMUNICIPIO,
                 :CDBAIRRO,
                 :NMBAIRROENDERECO,
                 :DSENDERECO,
                 :NRCEPENDERECO,
                 :DSCOMPLEENDERECO,
                 :NRIMOVELENDERECO
                )";
                 
        
            $std = $this->connection->prepare($insert);
            $std->execute($paramsInsertEndeparc);
        
        
    }
    
    public function setIdQualificadoProspect($paramsSetQualification){
        
        $update = "UPDATE PROSPECT 
                      SET IDQUALIFICADO = :IDQUALIFICADO    
                    WHERE CDPROSPECT = :CDPROSPECT
                        AND NRORG = :NRORG";
        
        
            $std = $this->connection->prepare($update);
            $std->execute($paramsSetQualification);
         
    }
    
    public function insertConcorrProspect($paramsInsertConcorrProspect){
        
        $insert = "INSERT INTO CRM_CONCORRPROSPECT
                        (NRCONCORRPROSPECT, CDPROSPECT, NRCONCORRENTE, NRORG, DTINIVIGENCIA, DTFIMVIGENCIA,
                            DTINCLUSAO, DTULTATU, NRORGINCLUSAO, NRORGULTATU, CDOPERINCLUSAO, CDOPERULTATU)
                    VALUES(
                        :NRCONCORRPROSPECT,
                        :CDPROSPECT,
                        :NRCONCORRENTE,
                        :NRORG,
                        :DTINIVIGENCIA,
                        :DTFIMVIGENCIA,
                         SYSDATE,
                         SYSDATE,
                        :NRORG,
                        :NRORG,
                        :CDOPERINCLUSAO,
                        :CDOPERINCLUSAO
                    )";
    
        
            $std = $this->connection->prepare($insert);
            $std->execute($paramsInsertConcorrProspect);
         
        
    }
    
    public function updateConcorrProspect($paramsSetConcorr){
        
        $update = "UPDATE CRM_CONCORRPROSPECT 
                      SET DTINIVIGENCIA = :DTINIVIGENCIA,
                          DTFIMVIGENCIA = :DTFIMVIGENCIA,
                          NRCONCORRENTE = :NRCONCORRENTE
                    WHERE NRCONCORRPROSPECT = :NRCONCORRPROSPECT
                        AND NRORG = :NRORG";
        
        
            $std = $this->connection->prepare($update);
            $std->execute($paramsSetConcorr);
         
    }
    
    public function deleteConcorrProspect($paramsDeleteConcorr){
        
        $delete = "DELETE FROM CRM_CONCORRPROSPECT 
                    WHERE NRCONCORRPROSPECT = :NRCONCORRPROSPECT
                        AND NRORG = :NRORG";
        
        
            $std = $this->connection->prepare($delete);
            $std->execute($paramsDeleteConcorr);
         
    }
    
    public function validaCNPJCliente($paramsSelectClient){
        $select = "SELECT NMRAZSOCCLIE
                     FROM CLIENTE
                    WHERE NRINSJURCLIE = :CNPJ
                      AND NRORG = :NRORG" ;
                      
        
            $std = $this->connection->prepare($select);
            $std->execute($paramsSelectClient);
            return $std->fetchAll();
        
    }
    
    public function createPartnership($params) {
        $queryInsertParceria = "INSERT INTO PARCERIA(NRPARCERIA, NRORG, NRPARCNEGOCIO, CDTIPOPARCEIRO, IDATIVO, DTINCLUSAO, CDOPERINCLUSAO, NRORGINCLUSAO)
        VALUES(:NRPARCERIA, :NRORG, :NRPARCNEGOCIO, :CDTIPOPARCEIRO, :IDATIVO, SYSDATE, :CDOPERINCLUSAO, :NRORGINCLUSAO)";
                      
        $std = $this->connection->prepare($queryInsertParceria);
        $std->execute($params);
    }
    
    public function setParceiroNegocio($params) {
        $insert = "INSERT INTO PARCNEGOCIO (NRPARCNEGOCIO, NRORG, NMPRINCIPALPARC, NMSECUNDARIPARC, NRINSCRICAOPARC, IDATIVO, DTINCLUSAO,
                         NRORGINCLUSAO, CDOPERINCLUSAO, CDTIPOPARCPRINCIPAL, CDTIPOINSCRICAO,IDPESSOAFISICA, CDOPERRESPONSAVEL)
                 VALUES (:NRPARCNEGOCIO,
                         :NRORG,
                         :NMPRINCIPALPARC,
                         :NMSECUNDARIPARC,
                         :NRINSCRICAOPARC,
                         :IDATIVO,
                          SYSDATE,
                         :NRORGINCLUSAO,
                         :CDOPERINCLUSAO,
                         :CDTIPOPARCPRINCIPAL,
                         :CDTIPOINSCRICAO,
                         :IDPESSOAFISICA,
                         :CDOPERRESPONSAVEL)";             
        $std = $this->connection->prepare($insert);
        $std->execute($params);
    }
    
    public function newContato($params){
        $query = "INSERT INTO CONTATO (CDPROSPECT, CDCLIENTE, CDFORNECED, DSREFECONT, IDSTATUSCONT, IDTPCONTATO, CDOPERCONT, NRORG, NRPARCNEGOCIO, IDATIVO, CDFILIAL, NRCONTATO, NRSEQCONTATO, DTHRCONTATO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO)
            SELECT PROS.CDPROSPECT, CLIE.CDCLIENTE, FORN.CDFORNECED, :DSREFECONT, :IDSTATUSCONT, :IDTPCONTATO, :CDOPERCONT, :NRORG, :NRPARCNEGOCIO, 'S' AS IDATIVO, :CDFILIAL, :NRCONTATO, :NRSEQCONTATO, SYSDATE AS DTHRCONTATO, SYSDATE AS DTINCLUSAO, :NRORG AS NRORGINCLUSAO, :CDOPERCONT
            FROM PARCNEGOCIO PARC LEFT JOIN PROSPECT PROS
            ON PARC.NRPARCNEGOCIO = PROS.NRPARCNEGOCIO AND PARC.IDATIVO = PROS.IDATIVO AND PARC.NRORG = PROS.NRORG
            LEFT JOIN CLIENTE CLIE
            ON PARC.NRPARCNEGOCIO = CLIE.NRPARCNEGOCIO AND PARC.IDATIVO = CLIE.IDATIVO AND PARC.NRORG = CLIE.NRORG
            LEFT JOIN FORNECEDOR FORN
            ON PARC.NRPARCNEGOCIO = FORN.NRPARCNEGOCIO AND PARC.IDATIVO = FORN.IDATIVO AND PARC.NRORG = FORN.NRORG
            WHERE PARC.NRPARCNEGOCIO = :NRPARCNEGOCIO AND PARC.NRORG = :NRORG AND PARC.IDATIVO = 'S'";        


        $std = $this->connection->prepare($query);
        $std->execute($params);

    }
    
    public function updateCliente($params) {
        $params2 = array(
            'NRPARCNEGOCIO' => $params['NRPARCNEGOCIO'],
            'CDOPERRESPONSAVEL' => $params['CDOPERRESPONSAVEL'],
            'NRORG' => $params['NRORG']
        );
        unset($params['CDOPERRESPONSAVEL']);
        
        $sql = "UPDATE CLIENTE
                SET IDTPIJURCLIE   = :IDTPIJURCLIE,
                    NMFANTCLIE     = :NMFANTCLIE,
                    IDPRIPUBCLIE   = :IDPRIPUBCLIE,
                    CDMODODIVULG   = :CDMODODIVULG,
                    CDATIVCLI      = :CDATIVCLI,
                    CDQUALIF       = :CDQUALIF,
                    NMRAZSOCCLIE   = :NMRAZSOCCLIE,
                    NRINSJURCLIE   = :NRINSJURCLIE,
                    CDSEGMER       = :CDSEGMER,
                    IDATIVO        = :IDATIVO,
                    VRFATUCLIE     = :VRFATUCLIE,
                    NRFUNCCLIE     = :NRFUNCCLIE,
                    DSHOMEPACLI    = :DSHOMEPACLI,
                    NRPARCNEGOCIO  = :NRPARCNEGOCIO,
                    NRINSESTCLIE   = :NRINSESTCLIE,
                    CDOPERULTATU   = :CDOPERADOR,
                    DTULTATU       = SYSDATE,
                    NRORGULTATU    = :NRORGOPER
                WHERE CDCLIENTE = :CDCLIENTE
                  AND NRORG     = :NRORG";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        
        $sql2 = "UPDATE PARCNEGOCIO
                 SET CDOPERRESPONSAVEL = :CDOPERRESPONSAVEL
                 WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO
                   AND NRORG     = :NRORG";
        
        $std = $this->connection->prepare($sql2);
        $std->execute($params2);
    }
}
?>