<?php
/**
 * Created by PhpStorm.
 * User: gustavolima
 * Date: 23/11/2015
 * Time: 16:21
 */

namespace Teknisa\CRM\Service;

use Doctrine\ORM\EntityManager;
use Teknisa\CRM\Util\Mail;
use Teknisa\CRM\Util\Environment;

class RecuperarSenhaService {

    private $dsemailoper;
    private $NrOrg;
    private $NmOperador;

    protected $entityManager;
    /** @var Environment */
    protected $environment;

    public function __construct(EntityManager $entityManager, Environment $environment) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
    }

    private function getTemplate($novasenha,$dsemailoper){

        $nmoperador = $this->NmOperador;

        $template = <<<HTML
                    <!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
                    <html>
                    <head>
                        <title>Recuperação de Senha</title>
                        <meta charset="ISO-8859-1">
                    </head>
                    <body style="text-align: center; padding-top: 2%; padding-left: 22%; background-color: rgb(118, 192, 179); margin: 0px; height: auto;">
                    <div style="width:672px; height:450px; box-shadow: 10px 10px 5px #78887d;">
                        <table cellpadding="0" cellspacing="0" style="width: 674px; height: 375px; margin: 0 auto;">
                            <tr style="background-color: #FFF">
                                <td height="20">
                                    &nbsp;
                                </td>
                            </tr>
                            <tr style="background-color: #FFF;">
                                <td style="text-align: center;">
                                    <img width="auto" height="auto" src="http://192.168.120.252:9090/diagnostics/mobile/images/pebbian-logo.png" />
                                </td>
                            </tr>
                            <tr style="background-color: #FFF">
                                <td height="35">
                                    &nbsp;
                                </td>
                            </tr>
                            <tr style="background-color: #FFF; text-align: left; font: normal 14px Arial, Tahoma, sans-serif; color: #333;">
                                <td>
                                    <table cellpadding="0" cellspacing="0">
                                        <tr>
                                            <td width="24"></td>
                                            <td height="193">
                                                <h1 style="text-align: center; font-size: 30px; padding-left: 90px;  margin: 0 0 15px 0; color: #1b9772;">Recuperação de Senha</h1>
                                                <h2 style="text-align: center; font-size: 15px; margin: 0 0 15px 0; color: #76c0b3;">Prezado(a) $nmoperador, sua nova senha foi gerada com sucesso!</h2>
                                                <p style="margin: 0; padding: 0 0 12px 0; line-height: 17px; text-align: justify;">
                                                    <b>Usuário:</b> $dsemailoper
                                                    <br><b>Senha:</b> $novasenha
                                            </p>
                                            </td>
                                            <td width="24"></td>
                                        </tr>
                                    </table>
                                </td>
                            </tr>
                            <tr style="background-color: #FFF">
                                <td>
                                    &nbsp;
                                </td>
                            </tr>
                            <tr style="background-color: #1b9772; color: #FFF; font: normal 13px Arial, Tahoma, sans-serif;">
                                <td height="17">
                                    &nbsp;
                                </td>
                            </tr>
                            <tr style="background-color: #1b9772; color: #FFF; font: normal 13px Arial, Tahoma, sans-serif;">
                                <td align="center">
                                    Este email é gerado automaticamente, não havendo necessidade de resposta.
                                </td>
                            </tr>
                            <tr style="background-color: #1b9772; color: #FFF; font: normal 13px Arial, Tahoma, sans-serif;">
                                <td height="10">
                                    &nbsp;
                                </td>
                            </tr>
                            <tr>
                                <td>
                                    <table cellpadding="0" cellspacing="0">
                                        <tr style="color: #FFF; font: normal 14px Arial, Tahoma, sans-serif; text-align: left;">
                                            <td style="text-align: center; padding-right: 10px; padding-top: 10px; padding-left: 30px;">
                                                <img height="40" src="http://192.168.120.252:9090/diagnostics/mobile/images/pebbian_logo_horizontal_completa_negativa.png" />
                                            </td>
                                            <td valign="bottom" style="text-align: center; padding-bottom: 10px; padding-left: 30px">
                                                <i>Pebbian Tecnológia em Software Mobile <br>  R. Pernambuco, 1000 - Funcionários, Belo Horizonte - MG</i>
                                            </td>
                                        </tr>
                                    </table>
                                    <br /><br /><br /><br /><br />
                                </td>
                            </tr>
                        </table>
                    </div>
                    </body>
                    </html>
HTML;

        return $template;

    }

    public function enviaEmailNovaSenha($email, $nrorg, $nmoperador = null){

        try {

            $this->NrOrg = $nrorg;
            $this->NmOperador = $nmoperador;
            $this->dsemailoper = $email;

            // Valida se o email é existente
            self::validaEmailExistente();

            // Gera nova senha.
            $senha = self::getNewPassword();

            // Criptografa senha, e atualiza no banco.
            $novasenha = md5($senha);
            self::updateSenhaOper($this->dsemailoper, $novasenha);

            $subject = 'Recuperação de Senha';
            $content = self::getTemplate($senha,$this->dsemailoper);

            // Manda um email para operador notificando a mudança de senha
            $return = new Mail($this->dsemailoper, $subject, $content);

            return $return;

        }
        catch(\Exception $e){
            throw new \Exception($e->getMessage(), $e->getCode());
        }

    }

    public function getNewPassword() {
        $password = rand(100000,999999);
        //$password = 'teknisa4';

        return $password;
    }

    public function updateSenhaOper($email, $senha)
    {
        // Query para update no banco de dados
        $update = " UPDATE OPERADOR
                    SET CDSENHAOPERWEB = '$senha'
                    WHERE DSEMAILOPER = '$email'
                      AND NRORG = '$this->NrOrg'";

        try {
            $this->entityManager->getConnection()->exec($update);
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage(), MCD_DBERROR_CODE);
        }
    }

    public function validaEmailExistente(){

        if (is_numeric($this->dsemailoper)) {
            $this->retornaEmailByCdoperador();
        }

        $sql = "SELECT NMOPERADOR
                FROM OPERADOR
                WHERE (DSEMAILOPER = '$this->dsemailoper')
                  AND NRORG = '$this->NrOrg'";

        try {
            $std = $this->entityManager->getConnection()->prepare($sql);
            $std->execute();
            $result = $std->fetchAll();

            if (count($result[0]) > 0) {
                $this->NmOperador = $result[0]['NMOPERADOR'];
                return true;
            } else {
                throw new \Exception("Email do operador não encontrado.'");
            }
        }
        catch (Exception $e) {
            throw new exception ($e->getMessage());
        }

    }

}