function crm00032000_FaseNegociacao_Controller(Utilities, ScreenService, templateManager, wizardEngine, Operador_Repository) {

    var self = this;

    this.iniciaFiltrosWidparamFaseNego = function(widget)
    {
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }
            Utilities.insertFilter(widget, "P_NRORG", "=", operator[0].NRORG, 0);
            Utilities.insertFilter(widget.getField("NRFIELDCRM"), "P_NRORG", "=", operator[0].NRORG, 0);
        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
    };

    this.setFilter = function() {
        var widgetFilha, widgetPai;
        var widget = templateManager.container.getActiveWidget();

        if(widget.name == 'paramFaseNego') {
            widgetFilha = widget;
            widgetPai = widget.parent;
        } else {
            widgetFilha = widget.widgets[0];
            widgetPai = widget;
        }

        widgetFilha.dataSourceFilter[1].value = widgetPai.currentRow.NRSEQFASENEGO;
    };

    this.save = function() {
        var widget = templateManager.container.getActiveWidget();
        
        if(Util.isEmptyOrBlank(widget.currentRow.NRORG)) {
            widget.currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
        }
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }

            self.removeItensRedundantes(widget);
            if(widget.isValid()) {
                widget.currentRow.changed = true;
                if(operator[0] === undefined || operator[0] === null)
                {
                    ScreenService.showMessage("Erro ao realizar a operação.");
                    return;
                }
                else if(widget.currentRow.__is_new)
                {
                    widget.currentRow.NRORGINCLUSAO = (widget.currentRow.NRORGINCLUSAO)? widget.currentRow.NRORGINCLUSAO : operator[0].NRORG;
                    widget.currentRow.CDOPERINCLUSAO = (widget.currentRow.CDOPERINCLUSAO)? widget.currentRow.CDOPERINCLUSAO : operator[0].CDOPERADOR;
                } else {
                    widget.currentRow.NRORGULTATU = (widget.currentRow.NRORGULTATU)? widget.currentRow.NRORGULTATU : operator[0].NRORG;
                    widget.currentRow.CDOPERULTATU = (widget.currentRow.CDOPERULTATU)? widget.currentRow.CDOPERULTATU : operator[0].CDOPERADOR;
                }

                widget.currentRow.NRSEQFASENEGO = widget.dataSourceFilter[1].value;
                return widget.saveRow().then(function(response){
                    widget.currentRow.changed = false;
                    widget.currentRow.__is_new = false;

                    ScreenService.closeSwipe();
                    widget.list();
                    widget.reload();
                });
            }
        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
    };

    this.removeItensRedundantes = function (widget){
        /*var indice = null;
        var ItensIncluidos = widget.dataSource.data;
        var novosItens = widget.currentRow.NRFIELDCRM;
        for(var i = 0; i < ItensIncluidos.length; i++){
            indice = novosItens.indexOf(ItensIncluidos[i].NRSEQCAMPOOBRIGA);
            if (indice >= 0){
                novosItens.splice(indice, 1);
            }
        }*/
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm00032000_FaseNegociacao_Controller', crm00032000_FaseNegociacao_Controller);
});